Continue working on libc symbol maps
[dragonfly.git] / UPDATING
CommitLineData
d2a0decc
MD
1# Updating Information for DragonFly users.
2#
3#
4# This file should warn you of any pitfalls which you might need to work around
5# when trying to update your DragonFly system. The information below is
6# in reverse-time order, with the latest information at the top.
7#
8# If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9# mailing list with the details.
d2a0decc 10
dbf3d3ba
JM
11+-----------------------------------------------------------------------+
12+ UPGRADING DRAGONFLY FROM 4.2 TO LATER VERSIONS +
13+-----------------------------------------------------------------------+
14
15SEVERAL LOCALES RENAMED
16-----------------------
17
18Several locales were using obsolete and misleading names, and thus have
19been adjusted to current standards. Any users of the following locales
20need to select alternates:
21
22DFLY 4.2 locale DFLY 4.4 alterative locale
23--------------- ------------------------------------
24mn_MN.UTF-8 mn_Cyrl_MN.UTF-8
25no_NO.UTF-8 nb_NO.UTF-8 or nn_NO.UTF-8
26no_NO.ISO8859-1 nb_NO.ISO8869-1 or nn_NO.ISO8859-1
27no_NO.ISO8859-15 nb_NO.ISO8859-15 or nn_NO.ISO8859-15
28sr_YU.UTF-8 sr_Cyrl_RS.UTF-8 or sr_Latn_RS.UTF-8
29sr_YU.ISO8859-5 sr_Cyrl_RS.ISO8859-5
30sr_YU.ISO8859-2 sr_Latn_RS.ISO8859-2
31zh_CN.GBK zh_Hans_CN.GBK
32zh_CN.UTF-8 zh_Hans_CN.UTF-8
33zh_CN.eucCN zh_Hans_CN.eucCN
34zh_CN.GB2312 zh_Hans_CH.GB2312
35zh_CN.GB18030 zh_Hans_CH.GB18030
36zh_HK.Big5HKSCS zh_Hant_HK.Big5HKSCS
37zh_HK.UTF_8 zh_Hant_HK.UTF-8
38zh_TW.Big5 zh_Hant_TW.Big5
39zh_TW.UTF-8 zh_Hant_TW.UTF-8
40
2a617999
SW
41+-----------------------------------------------------------------------+
42+ UPGRADING DRAGONFLY FROM 4.0 TO LATER VERSIONS +
43+-----------------------------------------------------------------------+
44
65c3b857
JM
45BINUTILS 2.25 REPLACES 2.22, PRIMARY
46------------------------------------
47
48The oldest of the two versions of Binutils, version 2.22, was removed
49and replaced with Binutils 2.25. It becomes the primary version version
50of binutils and version 2.24 becomes the alternate. There are 8 current
51CVE written against 2.24, so for security reasons version 2.25 should
52always be used.
53
54The accepted values of BINUTILSVER are now "binutils225" (default) and
55"binutils224". The building of Binutils 2.24 can be prevented by setting
56NO_ALTBINUTILS=yes in make.conf.
57
72b78560
JM
58LOADER OPTIONS CHANGED
59----------------------
60
61Right after the development branch started, the Fred art accompanying the
62loader menu was improved. The line between Fred and the menu was removed
63by default (but can optionally be returned) and the placement shifted as
64a result. The drawing was improved, and the colored version was improved,
65changing the eyes and wing color from white to red. A new color version
66of Fred was added, one with a blue scheme.
67
68The loader menu defaults have changed since release 4.0: The vertical
69line was removed, the loader is displayed in color by default*, and the
70blue scheme is used.
71
72The loader.conf changes are:
73loader_color: option has been removed
74loader_plain: option has been added, it changed menu to monochrome
75fred_is_red: changes color scheme from blue to red
76fred_is_blue: option existed only on 4.1, it has been removed
77fred_separated: Adds line between Fred and menu (as seen previously)
78
79* If loader.conf defines "console" as "comconsole" or "console" is defined
80 in the environment as "comconsole" then color will not be displayed,
81 even if loader_plain value is "NO".
82
cbab4ab1
JM
83SENDMAIL REMOVED FROM BASE
84--------------------------
85
86The only Mail Transfer Agent provided now is DragonFly Mail Agent (dma).
87If the system being upgraded is still configured to use the sendmail
88binaries from base, the "make upgrade" command will fail.
89
90The administrator must change /etc/mail/mailer.conf to switch the
91mailwrapper to dma or a DPorts-based MTA prior to running the upgrade
92command that permanently removes sendmail executables and could
93potentially break a running mail server.
94
95Refer: http://www.dragonflybsd.com/docs/docs/newhandbook/mta/ for
96detailed instructions on how to configure the MTA selection.
97
a7ac1ee9
SW
98_KPOSIX_VERSION and P1003_1B OPTIONS REMOVED
99--------------------------------------------
100
101The _KPOSIX_VERSION and P1003_1B kernel options have been changed to
102no-ops. They can be removed from custom kernel configurations.
103
aa7c3d6b
FT
104SOUND SYSTEM UPDATED FROM FreeBSD 11-CURRENT
105--------------------------------------------
106
107Many more sound devices may be detected.
108
109If the default device choosen isn't to your liking, setting the sysctl
110hw.snd.default_unit to a different number will change it.
111
60a260ad
SW
112SCTP SUPPORT DROPPED
113--------------------
114
115Support for the SCTP protocol has been removed.
116
2a617999
SW
117OLD USB DRIVERS REMOVED
118-----------------------
119
120The old USB stack, along with the kernel config option "device oldusb"
121and the make.conf variable "WANT_OLDUSB" have been removed. This means
122that for custom kernel configuration files which were derived from a
123GENERIC or X86_64_GENERIC file prior to making the usb4bsd stack default,
124various (old USB stack specific) devices will now complain about being
125unknown:
126
127 * oldusb (obviously)
128 * natausb (not yet ported to usb4bsd)
129 * rue (not yet ported to usb4bsd)
130 * ugen (no longer needed in usb4bsd)
131 * urio (not yet ported to usb4bsd)
132 * uscanner (no longer needed in usb4bsd)
133
134They should be removed or commented out in such custom kernel configs.
135
4e8e707f
JM
136GCC 5
137-----
138
139The GCC 4.4 compiler has been retired. It has been replaced by a GCC 5.1.
140The following make.conf variables no longer work: NO_GCC44, NO_OBJC, and
141NO_CXX. The latter was never documented and the latest versions of GCC are
142partially written in C++ so a C++ compiler is no longer optional. In
143practical terms it has not been optional for many years as other base
144components are also written in C++. The resource savings by avoiding
145building Objective-C compiler is so small, the complexity added by NO_OBJC
146internally was deemed a bad tradeoff so that is the reason for its removal.
147Also note that no "info" pages are installed with GCC 5. After this entry
148was originally written, all info pages were removed from DragonFly.
149
150GCC 5.1 has been designated as the primary compiler. As such, there is a
151new make.conf variable, NO_ALTCOMPILER. It will block the rebuilding of
152the designated secondary compiler, GCC 4.7. However, while DPorts
153primarily uses GCC 5 to build ports now, it still uses GCC 4.7 as well, so
154if building ports from source is desired, don't block building of the
155secondary compiler.
e9b676f1 156
0055c35b
SW
157+-----------------------------------------------------------------------+
158+ UPGRADING DRAGONFLY FROM 3.8 TO LATER VERSIONS +
159+-----------------------------------------------------------------------+
160
2a617999 161SMP AND DEVICE_POLLING OPTIONS MADE UNKNOWN
39b3e0a1
SW
162-------------------------------------------
163
164DEVICE_POLLING was replaced by IFPOLL_ENABLE and the former SMP code is
165the default now (even on single-core systems), both for, like, 21 months.
166We kept the options around as no-ops as a convenience, to allow people
167using the same config for the then current release and the then current
168master. That period is now over, so any configs still having those
169options have to be adjusted.
170
10ceb702
SW
171SYSVIPC SYSCALLS MADE NON-OPTIONAL
172----------------------------------
173
174The code related to the SYSVMSG, SYSVSEM and SYSVSHM kernel options is
175now compiled in by default. The options are no-ops for now.
176
79a3e83f
SW
177DEFAULT DRIVER CHANGED FOR LSI "THUNDERBOLT" SERIES RAID CONTROLLERS
178--------------------------------------------------------------------
179
180The default driver for those controllers is now mrsas(4) due to reports
181of file system corruption using the mfi(4) driver. The whole issue (and
182how to deal with potential problems when switching) was explained here:
183
184http://lists.dragonflybsd.org/pipermail/users/2014-July/128703.html
185
186A tunable is provided for letting those controllers still attach via
187the mfi(4) driver, hw.mrsas.mfi_enable (see mrsas(4) manual page).
188
0055c35b
SW
189OLDER NETWORK DRIVERS MOVED TO I386 ONLY
190----------------------------------------
191
192The following drivers have been made i386 only: ed(4), sr(4), ng_sync_ar
193and ng_sync_sr. ed(4) used to be in X86_64_GENERIC, so it has to be
194removed in kernel configs derived from X86_64_GENERIC.
195
e19e3c77 196+-----------------------------------------------------------------------+
62d4130d 197+ UPGRADING DRAGONFLY FROM 3.6 TO LATER VERSIONS +
e19e3c77
SW
198+-----------------------------------------------------------------------+
199
a6a7c140
JS
200UPDATE FROM MOST RECENT 3.6
201---------------------------
202
203Versions of 3.6 built before June 25th have a bug where installworld might
204crash during installation of the new initrd. Upgrade to the latest version
205of 3.6 before updating to 3.8 or later.
206
7c87aae6
SW
207ATM, IPX, NCP AND NWFS SUPPORT DROPPED
208--------------------------------------
6f25d555
SW
209
210Support for the IPX and NCP network protocols and for mouting NetWare
7c87aae6 211file systems has been dropped. Dito for ATM protocol support.
6f25d555
SW
212
213INITRD IMAGES NOW INSTALLED BY DEFAULT
214--------------------------------------
215
216An initial ramdisk image is now installed in /boot/kernel/initrd.img.gz
217
218Older images installed under the file name of initrd.img will be removed
219automatically by the make upgrade process.
220
f0478b8b
SW
221USB4BSD IS NOW THE DEFAULT USB STACK
222------------------------------------
223
224To get back to the old stack, put "WANT_OLDUSB=yes" in /etc/make.conf and
225replace "device usb" with "device oldusb" in the kernel configuration.
226
e19e3c77
SW
227MORE ISA SUPPORT DROPPED
228------------------------
229
230ISA support has been dropped from the following drivers: adv(4), an(4),
231ar(4), cs(4), digi(4), ed(4), ep(4), ex(4), fe(4), lnc(4), sbni(4),
232si(4), sn(4), and stg(4).
233
9332798a 234+-----------------------------------------------------------------------+
62d4130d 235+ UPGRADING DRAGONFLY FROM 3.4 TO LATER VERSIONS +
9332798a
SW
236+-----------------------------------------------------------------------+
237
c04df145
JS
238ABI CHANGE
239----------
240
241Installed third-party software (dports) will have to be rebuilt after upgrade,
242or reinstalled from binary packages.
243
2b455b95
JS
244UPDATING FROM 3.4 TO 3.6
245------------------------
246
247This only applies for this specific upgrade due to locale changes; it is
248not needed for upgrades after 3.6. Please update in this order:
249
250make buildworld
251make buildkernel
252make installworld
253make installkernel
254*reboot*
255make upgrade
256
257See this mailing list post for details:
258http://lists.dragonflybsd.org/pipermail/users/2013-September/090163.html
259
9332798a
SW
260CYRIX OPTIONS REMOVED
261---------------------
262
263The following Cyrix related options have been removed: CPU_BTB_EN,
264CPU_CYRIX_NO_LOCK, CPU_DIRECT_MAPPED_CACHE, CPU_DISABLE_5X86_LSSER,
265CPU_FASTER_5X86_FPU, CPU_IORT, CPU_LOOP_EN, CPU_RSTK_EN, CPU_SUSP_HLT,
266CYRIX_CACHE_WORKS, and CYRIX_CACHE_REALLY_WORKS
267
268ISA SUPPORT REMOVED FROM RP(4)
269------------------------------
270
271ISA support has been removed from the rp(4) driver. It is now PCI only.
272
64aeb497 273+-----------------------------------------------------------------------+
62d4130d 274+ UPGRADING DRAGONFLY FROM 3.2 TO LATER VERSIONS +
64aeb497
SW
275+-----------------------------------------------------------------------+
276
d88b9605
SW
277COMPAT_SUNOS OPTION REMOVED
278---------------------------
279
280The COMPAT_SUNOS option has been removed. It was meant to provide binary
281compatibility with SunOS 4.x for the sparc32 port of 4.4BSD.
282
43f215d7
SW
283ISA SOUND CARD SUPPORT REMOVED
284------------------------------
285
286The following modules have been removed (all for ISA sound cards):
287snd_ad1816.ko, snd_ess.ko, snd_mss.ko, snd_sb8.ko, snd_sb16.ko, snd_sbc.ko
288
6100d1de
JM
289GCC 4.7
290-------
291
292DragonFly has switched base compilers. GCC 4.7 is now the default
293compiler and GCC 4.4 is the alternative compiler. The "NO_GCC47" make
294variable ceases to work now.
295
296Users who wish to build only GCC 4.7 have to use NO_GCC44 in the
297/etc/make.conf to prohibit GCC 4.4 from building. However, using it is
298highly discouraged. There are a few packages in pkgsrc that do not build
299with GCC 4.7 and the new "DPorts" system uses GCC 4.4 by default. At
300this time, it is recommended to keep both compilers on the base system.
301
2089bb7c
SW
302SMP OPTION REMOVED
303------------------
304
305The SMP kernel option has been made a no-op. All kernels now feature SMP
306support. If you have 'options SMP' in your kernel config, you can as well
307remove it.
308
1c297ed0
SW
309DEVICE_POLLING OPTION REPLACED BY IFPOLL_ENABLE OPTION, KTR_POLLING REMOVED
310---------------------------------------------------------------------------
640dc18f
SZ
311
312The DEVICE_POLLING kernel option has been made a no-op and it has been
313replaced by IFPOLL_ENABLE. If you have 'options DEVICE_POLLING' in your
314kernel config, you need to change it to IFPOLL_ENABLE.
315
1c297ed0
SW
316Also, the KTR_POLLING kernel option has been removed, so it must be
317removed from kernel configs that have it.
318
558b0a0b
SW
319BUSLOGIC, CYCLADES AND STALLION ISA SUPPORT REMOVED
320---------------------------------------------------
850c4634
SW
321
322The bt(4) driver for Buslogic SCSI adapters has been made PCI only. ISA
323cards will no longer be detected.
324
e6f626a1
SW
325The same has been done for Stallion multiport serial controllers. stli(4)
326has been completely removed (along with the stlload(8) and stlstty(8)
558b0a0b
SW
327utilities) and stl(4) was changed to support only PCI cards. Similarly,
328ISA support was removed from cy(4) too. All these drivers are i386 only.
e6f626a1 329
e98bcb27
SW
330COMPAT_OLDISA OPTION GONE
331-------------------------
332
333The i386 specific COMPAT_OLDISA kernel option has been removed, since
334nothing needs it anymore.
335
c691bb43 336+-----------------------------------------------------------------------+
62d4130d 337+ UPGRADING DRAGONFLY FROM 3.0 TO LATER VERSIONS +
c691bb43
SW
338+-----------------------------------------------------------------------+
339
340APIC_IO OPTION REMOVED
341----------------------
342
343The APIC_IO kernel option is no longer accepted after having been without
344effect for a while. The hw.ioapic_enable tunable now serves its purpose.
345If you have 'options APIC_IO' in your kernel config, you'll have to
346remove it.
347
6d488cc3
SW
348WATCHDOG_ENABLE & HW_WDOG OPTIONS REMOVED
349-----------------------------------------
cf03d6cd
SW
350
351The wdog framework is now compiled into our kernels by default, so the
6d488cc3 352options are no longer needed.
cf03d6cd 353
397ffc5c
SW
354DOSCMD(1) REMOVED
355-----------------
356
357doscmd(1) has been removed. It was i386 only. The doscmd(1) specific
358NO_X make.conf option was removed too.
359
a1404d4f
SW
360GCC 4.7
361-------
362
363GCC 4.7 has been brought in and replaces GCC 4.1 as DragonFly's non-
364default compiler in base (default is still GCC 4.4).
365
366Users who wish to build only GCC 4.4 have to replace NO_GCC41 with
367NO_GCC47 in /etc/make.conf.
368
2508820f
SW
369USB4BSD
370-------
371
372A new USB stack (from FreeBSD) has been brought in. The following
373modules have been ported so far: usb, uhci, ohci, ehci, xhci, umass,
374usfs, uether, if_axe, if_udav, ukbd, ums, uep, uhid, usb_quirk,
375and uaudio.
376
377It is not yet the default. To activate it, WANT_USB4BSD=yes has to
c7200221
SW
378be put in make.conf and device "usb4bsd" (quotes needed) has to
379replace device usb in the kernel config. After that, a full
380build/install/upgrade cycle is needed.
2508820f
SW
381
382Note that this is experimental and incomplete, but we are interested
383in hearing about issues with it, of course.
384
ae0870a3
SW
385ISA SUPPORT REMOVED FROM AIC-6260/6360 DRIVER
386---------------------------------------------
387
388ISA adapter support was dropped from the aic(4) driver.
389
96386d4b 390+-----------------------------------------------------------------------+
62d4130d 391+ UPGRADING DRAGONFLY FROM 2.10 TO LATER VERSIONS +
96386d4b
SW
392+-----------------------------------------------------------------------+
393
394SEVERAL ISA DRIVERS REMOVED
395---------------------------
396
397The following ISA only drivers have been removed along with a couple of
398associated userland tools:
399
400aha(4)
401asc(4) & sasc(1)
402ctx
403dgb(4)
404el(4)
405gpib
406gsc(4) & sgsc(1)
407ie(4)
408labpc(4)
409le(4)
410mse(4)
411rc(4)
412rdp(4)
413spigot
414tw(4) & xten(1) & xtend(8)
415wl(4) & wlconfig(8)
416wt(4)
417
418Note that two of these drivers (aha(4) and ie(4)) are in our GENERIC
419config and one (aha(4)) is in our X86_64_GENERIC kernel configuration
420file.
421
422If buildkernel complains about any of these drivers, just remove them
423from your kernel configuration.
424
919eb219
JM
425BINUTILS 2.20
426-------------
37c5a0db 427Binutils 2.20 has been removed in favor of Binutils 2.22. The accepted
e685772e 428values of BINUTILSVERS are now binutils221 and binutils222 (default).
919eb219 429
83bc1e2a
SW
430BUILDWORLD/-KERNEL PARALLELIZATION WORK
431---------------------------------------
432Due to changes in the way we build with more than one make job, you
433will have to update install(1) and mkdir(1) prior to buildworld if you
434want to build with 'make -j':
435
436cd /usr/src/usr.bin/xinstall; make; make install; make clean
437cd /usr/src/bin/mkdir; make; make install; make clean
438
eca86bd9
SW
439DMA(8) UPGRADE
440--------------
441dma(8) has been upgraded to v0.7 which no longer supports the
442/etc/dma/virtusertable. Some of its functionality has been replaced
443with the MASQUERADE keyword and the EMAIL environment variable (see
444the dma(8) manual page).
445
a4a39c94 446+-----------------------------------------------------------------------+
62d4130d 447+ UPGRADING DRAGONFLY FROM 2.8 TO LATER VERSIONS +
a4a39c94
JS
448+-----------------------------------------------------------------------+
449
b1242318
SW
450GCC 4.4 & BINUTILS 2.21
451-----------------------
30c91f0c 452
b1242318
SW
453GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
454been made DragonFly's default Binutils.
30c91f0c
SW
455
456That means that any settings that set CCVER to 'gcc44' are not needed
457anymore. Instead, CCVER can be set to 'gcc41' to go back to using
458GCC 4.1.
459
b1242318
SW
460It also means that 'binutils221' as a value for BINUTILSVER has no
461effect anymore. 2.17 has been removed and 'binutils220' is available
462as an option.
463
5738210d 464The NO_GCC44 option has been removed and will not affect the build
30c91f0c
SW
465anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
466building in a similar fashion.
467
80abb3be 468Note that you must do a full buildworld/buildkernel for upgrading.
30c91f0c 469
a4a39c94 470pkg_radd settings
c983d16e 471-----------------
a4a39c94
JS
472
473The config file for pkg_radd has moved from /etc/settings.conf to
474/etc/pkg_radd.conf. Save the contents of settings.conf before upgrading
475if this is needed. This warning only applies if /etc/settings.conf
476exists. pkg_radd will continue to work with defaults.
477
b79f66dd 478+-----------------------------------------------------------------------+
72fe41d3 479+ 20100927 +
1bb1cc14 480+ UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD +
b79f66dd
JT
481+-----------------------------------------------------------------------+
482
72fe41d3 483OpenSSL
c983d16e 484--------
72fe41d3
PA
485
486OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
487This shouldn't break any 3rd-party software, but you'll need to recompile your
4883rd-party software if you want it to link against the new version of OpenSSL.
489
8eb0b612 490Loader
c983d16e 491-------
8eb0b612 492
b79f66dd
JT
493A new loader (dloader) has been added which better handles booting from
494multiple kernel/module versions.
495
496To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
497
498 cd /usr/src
499 make buildworld
500 make installworld
501 make upgrade
502 make buildkernel KERNCONF=<KERNELNAME>
503 make installkernel KERNCONF=<KERNELNAME>
504
505Note that you must installworld and run the 'upgrade' target before
506installing the new kernel.
507
8eb0b612 508BIND
c983d16e 509-----
8eb0b612
JS
510
511BIND has been removed from the base system. The ldns and drill tools have
512been added for basic functionality. Use 'drill' where you would normally
513use nslookup or dig, or install BIND from pkgsrc. It's available as
514net/bind95, net/bind96, or net/bind97 as of this writing.
515
516This only affects older systems upgrading to 2.8. New 2.8+ installs
517include BIND as a pkgsrc package.
518
d2a0decc
MD
519+-----------------------------------------------------------------------+
520+ UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM +
521+ GENERAL +
522+-----------------------------------------------------------------------+
984263bc 523
a700883c
SW
524Instructions on how to obtain and maintain DragonFly source code using git
525are in the development(7) manual page.
d2a0decc
MD
526
527To upgrade a DragonFly system from sources you run the following sequence:
528
529 cd /usr/src
530 make buildworld
531 make buildkernel KERNCONF=<KERNELNAME>
532 make installkernel KERNCONF=<KERNELNAME>
533 make installworld
534
535You will also want to run the 'upgrade' target to upgrade your /etc and the
536rest of your system. The upgrade target is aware of stale files created by
537older DragonFly installations and should delete them automatically.
538
539 make upgrade
540
a700883c
SW
541See the build(7) manual page for further information.
542
d2a0decc
MD
543Once you've done a full build of the world and kernel you can do incremental
544upgrades of either by using the 'quickworld' and 'quickkernel' targets
545instead of 'buildworld' and 'buildkernel'. If you have any problems with
a700883c 546the quick targets, try updating your repo first, and then a full buildworld
d2a0decc 547and buildkernel as shown above, before asking for help.
4523a2c0
TN
548
549+-----------------------------------------------------------------------+
550+ UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1 +
551+-----------------------------------------------------------------------+
552
553In 2.1 kernel and modules has moved to boot directory. For most cases
554this is handled automatically by 'make upgrade'. A few cases needs manual
555intervention:
556
557 * When installing a kernel without first doing a make buildworld,
558 installworld and upgrade to the same DESTDIR as kernel:
559 make DESTDIR/boot directory and move kernel and modules into this boot
560 directory; also move kernel.old and modules.old.
561 Typical example is vkernel(7), use (no modules used):
562
563 cd /var/vkernel
564 mkdir boot
565 chflags noschg kernel
566 mv kernel kernel.old boot
567 chflags schg boot/kernel
568
569 * When using a boot-only partition, /boot/loader.rc needs to be edited:
570 delete occurrences of '/boot/'.
571 These occurences can normally be deleted in any case, see loader(8).
d2a0decc
MD
572
573+-----------------------------------------------------------------------+
574+ UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9 +
575+-----------------------------------------------------------------------+
576
577In 1.9 major changes to the disk management infrastructure have taken
578place. make upgrade may not catch all of your disk devices in /dev,
579so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
45e80934
MD
580are all of your disk devices. HOWEVER, from late 2.3 on we run devfs
581and MAKEDEV no longer exists.
d2a0decc
MD
582
583The biggest changes in 1.9 are:
584
585(1) That whole-slice devices such as da0s1 no longer share the same device
586 id as partition c devices such as da0s1c.
587
588(2) The whole-disk device (e.g. da0) is full raw access to the disk,
589 with no snooping or reserved sectors. Consequently you cannot run
590 disklabel on this device. Instead you must run disklabel on a
591 whole-slice device.
592
593(3) The 'compatibility' partitions now use slice 0 in the device name,
594 so instead of da0a you must specify da0s0a. Also, as per (1) above,
595 accessing the disklabel for the compatibility partitions must be
596 done via slice 0 (da0s0).
597
598(4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
599 and CCD now run through the disk management layer and are assigned
600 real disk management devices. VN and CCD in particular do not usually
601 use a MBR and disklabels must be accessed through the compatibility
602 slice 0. Your /etc/ccd.conf file still specifies 'ccd0', though, you
603 don't name it 'ccd0s0' in the config file.
604
605Generally speaking, you have to get used to running fdisk and disklabel on
606the correctly specified device names. A lot of the wiggle, such as running
607disklabel on a partition, has been removed.
608
609+-----------------------------------------------------------------------+
610+ UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD +
611+-----------------------------------------------------------------------+
612
613> Kerberos IV
614-------------
615
616Kerberos IV (eBones) was removed from the tree, please consider moving to
617Kerberos 5 (Heimdal).
618
619> Package Management System
620---------------------------
621
622Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
623management system. The necessary tools to build and maintain packages
624are provided in /usr/pkg/bin and /usr/pkg/sbin. Make sure that these
625directories are in your PATH variable.
626
627In order to obtain a reasonably current snapshot of the pkgsrc tree, use
628the tarball from NetBSD:
629
630 fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
631 cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
632
633This tree can then be kept up to date with cvs update:
634
635 cd /usr/pkgsrc; cvs up
636
637NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
638build and install the pkgsrc bootstrap manually:
639
640 cd /usr/pkgsrc/bootstrap
641 ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
642
643+-----------------------------------------------------------------------+
644+ UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM +
645+ UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO +
646+ DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD) +
647+-----------------------------------------------------------------------+
58116288 648
114580ac 649The compatibility shims for the build environment have been removed, you
58116288
JS
650have to update to DragonFly 1.2 release branch first.
651
1fcc7462
JS
652The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
653The existing configuration can be converted using /etc/pam.d/convert.sh.
654Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
655the pam_skey.so module was retired, you have to remove it manually from
656your configuration, when you convert it.
58116288 657
a3107071
MD
658> Required user and group IDs when upgrading from either FreeBSD or DragonFly
659---------------------
660
661The following users may be missing from your password file. Use vipw and
662add any that are missing:
663
664smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
dcf85892 665_pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
a3107071
MD
666
667The following groups may be missing from your group file. Use vi /etc/group
668and add any that are missing:
669
670smmsp:*:25:
671authpf:*:63:
dcf85892 672_pflogd:*:64:
a3107071
MD
673
674
f419daca 675> Upgrading to DragonFly from FreeBSD
5e0ae0d4 676---------------------
984263bc 677
f419daca
MD
678You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
679FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
680FreeBSD. Note that the DragonFly buildworld target does not try to reuse
681make depend information, it starts from scratch, so no pre-cleaning of the
682object hierarchy is necessary.
683
466bbc10 684 # get the CVS repository (it is placed in /home/dcvs, 500MB).
f419daca
MD
685 # Please use the -h option and a mirror site to pull the
686 # initial repository, but feel free to use the main repository
687 # machine to pull updates.
5010eeb3 688 cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
f419daca
MD
689 # install the source from the CVS hierarchy (remove preexisting
690 # FreeBSD src first) (500MB)
691 cd /usr
692 rm -rf src
50172b1c 693 cvs -R -d /home/dcvs checkout -P src
f419daca
MD
694
695 # build it (500MB used in /usr/obj)
696 #
697 cd /usr/src
698 make buildworld
699 make buildkernel KERNCONF=<KERNELNAME>
984263bc 700
f419daca
MD
701Once you have built DragonFly you have to install it over FreeBSD. Since
702DragonFly does not track changes made by FreeBSD to its include file
703hierarchy and include file pollution can cause all sorts of unexpected
704compilation issues to come up, it is best to wipe your include hierarchy
705prior to installing DragonFly. Note that you should not wipe any installed
706FreeBSD header files or binaries until after you have successfully completed
707the build steps above.
fb12f484 708
f419daca
MD
709 rm -rf /usr/include
710 mkdir /usr/include
711 make installkernel KERNCONF=<KERNELNAME>
712 make installworld
fb12f484 713
b8cbf045 714Then you need to upgrade your system. DragonFly's 'make upgrade' target
f419daca 715will unconditionally upgrade the /etc files that sysops do not usually
b8cbf045
SW
716mess around with, such as the files in /etc/rc.d. It will also remove any
717obsolete files such as utilities and manpages that have been removed from
718the system since the version you're coming from. If you are unsure we
719recommend that you make a backup of at least your /etc before applying
720this step. Note that DragonFly's RC system is basically RCNG from
721FreeBSD-5, but there are some differences in the contents of the RC files.
f419daca
MD
722
723 make upgrade
724
b8cbf045
SW
725NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
726Doing so might leave your system in an unusable state.
727
f419daca 728Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
b8cbf045
SW
729/usr/bin, and /usr/lib, and remove any stale files that you find. Please
730report these files to the DragonFly developers so that they can be added to
731the 'upgrade' target.
f419daca 732